subroutine listwintervals(NREC,SYMH,BZGSM,ISWFLAG,IMFFLAG,INR,IBEG,IEND)

	implicit none
	INTEGER IBEG, IEND, INR, LENGTH_QUIET, IND_FIRST_GOOD, INDBEG, IND, ISWFLAG, IMFFLAG, NREC
	REAL SYMHMAX, SYMHMIN, SYMH, BZGSM, SYMH_LOWLIM, DSYMH_LIM
	DIMENSION IBEG(NREC),IEND(NREC),SYMH(NREC),IMFFLAG(NREC),ISWFLAG(NREC),BZGSM(NREC)
	LENGTH_QUIET=0
	IND=0  !  IND IS THE # OF THE CURRENT RECORD; HERE WE INITIALIZE IT WITH 0
	INR = 0
	SYMH_LOWLIM=-10.D0  !  LOW LIMIT ON SYMH DURING THE 2-HOUR "QUIET-TIME PERIOD"
	DSYMH_LIM=    5.D0  !  UPPER LIMIT ON THE SYMH VARIATION RANGE DURING THE ABOVE QUIET PERIOD


	SYMHMAX=-1000.
	SYMHMIN=+1000.

3	IND=IND+1
	IF (IND.EQ.NREC) GOTO 6
	IF (SYMH(IND).GT.SYMHMAX) SYMHMAX=SYMH(IND)
	IF (SYMH(IND).LT.SYMHMIN) SYMHMIN=SYMH(IND)

	IF ((IMFFLAG(IND).EQ.-1).OR.(ISWFLAG(IND).EQ.-1).OR.(BZGSM(IND).LT.0.D0).OR.(SYMH(IND).LT.SYMH_LOWLIM)) THEN
		LENGTH_QUIET=0
		SYMHMAX=-1000.
		SYMHMIN=+1000.
		GOTO 3  !  THE RECORD DIDN'T MEET THE FIRST 3 REQUIREMENTS (DATA AVAILABLE, IMF_BZ>=0, SYMH>=SY,H_LOWLIM),
	ENDIF

	IF (LENGTH_QUIET.EQ.0) IND_FIRST_GOOD=IND  !  MARKS THE FIRST RECORD THAT SATISFIED THE FIRST 3 REQUIREMENTS

	IF (SYMHMAX-SYMHMIN.GT.DSYMH_LIM) THEN
		IND=IND_FIRST_GOOD+1
		LENGTH_QUIET=0
		SYMHMAX=-1000.
		SYMHMIN=+1000.
		GOTO 3
	ENDIF

	LENGTH_QUIET=LENGTH_QUIET+1    !  FIRST SATISFACTORY RECORD HAS BEEN REACHED

	IF (LENGTH_QUIET.EQ.24) THEN   !  LENGTH OF THE CURRENT QUIET INTERVAL REACHED 2 HRS, SO
		INDBEG=IND   ! INDBEG CORRESPONDS TO THE LAST RECORD OF THE QUIET-TIME PERIOD

		DO 5 IND=INDBEG,NREC
			IF ((IMFFLAG(IND).EQ.-1).OR.(ISWFLAG(IND).EQ.-1)) THEN  !  FIRST RECORD OF THE NEXT GAP ENCOUNTERED
				IEND(INR+1)=IND-1
				IBEG(INR+1)=INDBEG-LENGTH_QUIET+1   !  HERE INDBEGIN CORRESPONDS TO THE BEGINNING OF THE FIRST RECORD
				INR = INR+1
				LENGTH_QUIET=0
				SYMHMAX=-1000.
				SYMHMIN=+1000.
				GOTO 3
			ENDIF  !  END OF THE CASE "IMFFLAG(IND).EQ.-1).OR.(ISWFLAG(IND).EQ.-1"
5		CONTINUE

		IEND(INR+1)=NREC-1
		IBEG(INR+1)=INDBEG-LENGTH_QUIET+1
		GOTO 6
	ENDIF   !    END OF THE CASE "IF (LENGTH_QUIET.EQ.24)"
	GOTO 3

6	RETURN
	END


subroutine calculatew(NREC,INDBEG,INDEND,NDATA,BZ,V,DEN,W1O,W2O,W3O,W4O,W5O,W6O)

	implicit none
	integer NREC,INDBEG,INDEND,NDATA,N,IND,INDB,INDE,KEY1,KEY2,KEY3,KEY4, &
			KEY5,KEY6,KK
	real BZ,V,DEN,W1O,W2O,W3O,W4O,W5O,W6O,W1,W2,W3,W4,W5,W6,Vnorm,Dennorm, &
		Bsnorm,Bs1,Bs2,Bs3,Bs4,Bs5,Bs6,FAC1,FAC2,FAC3,FAC4,FAC5,FAC6,TAUMT, &
		ARG1,ARG2,ARG3,ARG4,ARG5,ARG6,DT1,DT2,DT3,DT4,DT5,DT6

	DIMENSION BZ(NDATA),V(NDATA),DEN(NDATA),W1O(NDATA), &
			W2O(NDATA),W3O(NDATA),W4O(NDATA),W5O(NDATA), &
			W6O(NDATA),INDBEG(NREC),INDEND(NREC)


	real, dimension(6) :: r
	real, dimension(6) :: gamm
	real, dimension(6) :: lamda
	real, dimension(6) :: beta
	
	r = (/0.383403,0.648176,0.318752E-01,0.581168,1.15070,0.843004/)
	gamm = (/0.916555,0.898772,1.29123,1.33199,0.699074,0.537116/)
	lamda = (/0.394732,0.550920,0.387365,0.436819,0.405553,1.26131/)
	beta = (/0.846509,0.180725,2.26596,1.28211,1.62290,2.42297/)

	DT1=r(1)/60.   !  A(45) ... A(50) are in 1/hours, while DT1 ... DT6 are in 1/minutes
	DT2=r(2)/60.
	DT3=r(3)/60.
	DT4=r(4)/60.
	DT5=r(5)/60.
	DT6=r(6)/60.

	DO 555 N=1,NREC
		WRITE(*,'(A,I4,A,I4)')  "Calculating W for interval ",N," of ",NREC
		INDB=INDBEG(N)
		INDE=INDEND(N)

		DO 41 IND=INDB,INDE

			W1=0.
			W2=0.
			W3=0.
			W4=0.
			W5=0.
			W6=0.

			KEY1=1
			KEY2=1
			KEY3=1
			KEY4=1
			KEY5=1
			KEY6=1

			DO 42 KK=IND,INDB,-1

				Vnorm=   V(KK)/400.
				Dennorm= DEN(KK)*1.16/5. !  ASSUME HeH=0.04, HENCE 1.16
				Bsnorm= -BZ(KK)/5.

				IF (Bsnorm.LE.0.) THEN
					Bs1=0.D0
					Bs2=0.D0
					Bs3=0.D0
					Bs4=0.D0
					Bs5=0.D0
					Bs6=0.D0
				ELSE
					Bs1=Bsnorm**lamda(1)
					Bs2=Bsnorm**lamda(2)
					Bs3=Bsnorm**lamda(3)
					Bs4=Bsnorm**lamda(4)
					Bs5=Bsnorm**lamda(5)
					Bs6=Bsnorm**lamda(6)
				ENDIF

				FAC1=Dennorm**gamm(1) *Vnorm**beta(1) *Bs1
				FAC2=Dennorm**gamm(2) *Vnorm**beta(2) *Bs2
				FAC3=Dennorm**gamm(3) *Vnorm**beta(3) *Bs3
				FAC4=Dennorm**gamm(4) *Vnorm**beta(4) *Bs4
				FAC5=Dennorm**gamm(5) *Vnorm**beta(5) *Bs5
				FAC6=Dennorm**gamm(6) *Vnorm**beta(6) *Bs6

				TAUMT=(IND-KK)*5.

				ARG1=-TAUMT*DT1
				ARG2=-TAUMT*DT2
				ARG3=-TAUMT*DT3
				ARG4=-TAUMT*DT4
				ARG5=-TAUMT*DT5
				ARG6=-TAUMT*DT6

				IF (ARG1.GT.-10..AND.KEY1.EQ.1) THEN
					W1=W1+FAC1*EXP(ARG1)
				ELSE
					KEY1=0
				ENDIF

				IF (ARG2.GT.-10..AND.KEY2.EQ.1) THEN
					W2=W2+FAC2*EXP(ARG2)
				ELSE
					KEY2=0
				ENDIF
				
				IF (ARG3.GT.-10..AND.KEY3.EQ.1) THEN
					W3=W3+FAC3*EXP(ARG3)
				ELSE
					KEY3=0
                ENDIF

				IF (ARG4.GT.-10..AND.KEY4.EQ.1) THEN
					W4=W4+FAC4*EXP(ARG4)
				ELSE
					KEY4=0
				ENDIF

				IF (ARG5.GT.-10..AND.KEY5.EQ.1) THEN
					W5=W5+FAC5*EXP(ARG5)
				ELSE
					KEY5=0
				ENDIF

				IF (ARG6.GT.-10..AND.KEY6.EQ.1) THEN
					W6=W6+FAC6*EXP(ARG6)
				ELSE
					KEY6=0
				ENDIF


				IF (KEY1.EQ.0.AND.KEY2.EQ.0.AND.KEY3.EQ.0.AND.KEY4.EQ.0.AND.KEY5.EQ.0.AND.KEY6.EQ.0) GOTO 43


42			CONTINUE


43			W1O(IND)=W1*DT1*5.
			W2O(IND)=W2*DT2*5.
			W3O(IND)=W3*DT3*5.
			W4O(IND)=W4*DT4*5.
			W5O(IND)=W5*DT5*5.
			W6O(IND)=W6*DT6*5.


41		CONTINUE
555	CONTINUE
			

	RETURN
	END		
